package algorithms;


import java.awt.BorderLayout;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.PrintStream;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Locale;
import java.util.Timer;
import java.util.TimerTask;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JLabel;

import nanoxml.XMLElement;
import util.AscendingOrderMyNodeComparator;
import util.Edge;
import util.EditPath;
import util.GRECCostFunction;
import util.Graph;
import util.GraphComponent;
import util.ICostFunction;
import util.IEdgeHandler;
import util.LetterCostFunction;
import util.MutagenCostFunction;
import util.MyTree;
import util.UnDirectedEdgeHandler;
import util.UniversalEdgeHandler;
import util.MyTree.MyNode;
import util.Node;
import xml.XMLParser;

public class GEDDFS {

	//double wctAvant;  
	MyTree OPEN; // Tiens  jour la liste des noeud non encore utiliss. Le score du chemin.

	private Graph G1; //Graph 1	
	private Graph G2; //Graph 2
	private Node CurVertex=null; //Current node
	private int G2NbNodes; //Number of nodes of G2
	public int openCounterSize; // a variable that tracks the maximum size of the set OPEN
	public  int editPathCounter; // a variable that tracks number of edit paths

	//debug info
	//debug variable
	public int nbexlporednode=0;
	public int maxopensize=0;


	boolean debug;

	private double UBCOST;

	private EditPath UB;

	private int heuristicmethod;

	private EditPath CurLevel;

	private AscendingOrderMyNodeComparator MyNodeComparator;

	private int ubmethod;





	////////////////////////////////////////////////////////////////////////////////////////////
	public GEDDFS(Graph G1, Graph G2,ICostFunction costfunction, IEdgeHandler edgehandler,int heuristic, int ubmethod,boolean variableordering,boolean debug){
		inittimer();

		//	testdebugdistortion(G1,G2);

		this.debug = debug;
		this.G1 =G1;
		this.G2=G2;
		G2NbNodes = G2.size(); // Number of nodes of G2

		UBCOST = Double.MAX_VALUE;
		heuristicmethod = heuristic;
		this.ubmethod = ubmethod;
		//heuristicmethod = EditPath.HausdorffEDHeuristic;
		//La liste OPEN est initialise  VIDE. OPEN est une liste de chemin
		//Zeina: The set open contains the search tree nodes to be processed in the next steps
		EditPath ROOT = new EditPath(G1,G2,this.heuristicmethod,variableordering);
		MyNodeComparator =new AscendingOrderMyNodeComparator(heuristicmethod);
		OPEN = new MyTree<EditPath>(ROOT,MyNodeComparator);

		//test si l'on a une premire borne sup calcul lors du prprocessing
		if(Constants.FirstUB==null || ubmethod!=MunkresUB){
			//avant la boucle
			UB = ComputeUpperBound(ubmethod);
		}else{
			UB = Constants.FirstUB;
			this.UBCOST=UB.getTotalCosts();
			Constants.FirstUB=null;
		}



		inti();


		UB = loop();

		task.cancel();
		Constants.timer.purge();
		Constants.edgecostmatrix=null;
		Constants.nodecostmatrix=null;
	}


	public GEDDFS(Graph G1, Graph G2,ICostFunction costfunction, IEdgeHandler edgehandler,int heuristic, int ubmethod,boolean variableordering,boolean debug,boolean anytime){
		inittimer();

		//	testdebugdistortion(G1,G2);

		this.debug = debug;
		this.G1 =G1;
		this.G2=G2;
		G2NbNodes = G2.size(); // Number of nodes of G2

		UBCOST = Double.MAX_VALUE;
		heuristicmethod = heuristic;
		this.ubmethod = ubmethod;
		//heuristicmethod = EditPath.HausdorffEDHeuristic;
		//La liste OPEN est initialise  VIDE. OPEN est une liste de chemin
		//Zeina: The set open contains the search tree nodes to be processed in the next steps
		EditPath ROOT = new EditPath(G1,G2,this.heuristicmethod,variableordering);
		MyNodeComparator =new AscendingOrderMyNodeComparator(heuristicmethod);
		OPEN = new MyTree<EditPath>(ROOT,MyNodeComparator);

		//test si l'on a une premire borne sup calcul lors du prprocessing
		if(Constants.FirstUB==null || ubmethod!=MunkresUB){
			//avant la boucle
			UB = ComputeUpperBound(ubmethod);
		}else{
			UB = Constants.FirstUB;
			this.UBCOST=UB.getTotalCosts();
			Constants.FirstUB=null;
		}



		inti();



	}

	private void testdebugdistortion(Graph g12, Graph g22) {
		// TODO Auto-generated method stub
		EditPath ED = new EditPath(g12,g22);
		ED.complete();
		if(ED.distortions.size()==1){
			System.out.println("Erreur la table de hachage distortion ne peut pas prendre en entre plusieurs insertions");
		}
		ED.printMe();
		try {
			System.in.read();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	protected boolean timeconstraint=false;

	private Timer timer;

	private boolean issolutionoptimal=false;

	private TimerTask task;

	private Node PriorCurVertex;

	public static int MunkresUB=0;
	public static int DummyUB=1;

	public boolean isTimeconstraintover() {
		return timeconstraint;
	}

	private void inittimer() {
		// TODO Auto-generated method stub
		task = new TimerTask()
		{
			@Override
			public void run() 
			{
				timeconstraint=true;
			}	
		};

		//timer = new Timer();
		Constants.timer.scheduleAtFixedRate(task, Constants.timeconstraint, Constants.timeconstraint);
		//timer.scheduleAtFixedRate(task, 0, 100);
	}


	private EditPath ComputeUpperBound(int upperboundmethod) {
		// TODO Auto-generated method stub

		EditPath res=null;

		if(upperboundmethod ==-1){
			UBCOST = Double.MAX_VALUE;
			res = null;
		}

		if(upperboundmethod == MunkresUB){
			MatrixGenerator mgen = new MatrixGenerator();
			Munkres munkres = new Munkres();
			MunkresRec munkresRec = new MunkresRec();
			mgen.setMunkres(munkresRec);

			double[][] matrix = mgen.getMatrix(this.G1, G2);
			munkres.setGraphs(G1, G2);
			UBCOST = munkres.getCosts(matrix);
			res = munkres.ApproximatedEditPath();
			//EditPath ROOT = new EditPath(this.G1,this.G2,this.heuristicmethod); 
			//res = this.dummyUpperBound(ROOT);
			UBCOST = res.getTotalCosts();


		}

		if(upperboundmethod == this.DummyUB){
			EditPath ROOT = new EditPath(this.G1,this.G2); 
			res = this.dummyUpperBound(ROOT);
			res.setHeuristicmethod(this.heuristicmethod);
			res.complete();
			UBCOST = res.getTotalCosts();

		}
		return res;
	}

	private EditPath dummyUpperBound(EditPath p) {
		EditPath ptmp=null;
		if(p.isComplete() == false){
			ptmp = new EditPath(p);
			// TODO Auto-generated method stub
			int G1NbNodes = ptmp.getUnUsedNodes1().size();
			int G2NbNodes = ptmp.getUnUsedNodes2().size();
			// Substitution case
			//System.out.println("Substitution phase");
			for(int i=0;i<G1NbNodes  ;i++)
			{

				Node u = (Node) ptmp.getUnUsedNodes1().getFirst();
				if(i<G2NbNodes) {
					Node v = (Node) ptmp.getUnUsedNodes2().getFirst();
					ptmp.addDistortion(u, v);
				}

			}

			//Deletion case
			if(G1NbNodes > G2NbNodes)
			{
				//System.out.println("Deletion phase");
				int noOfDeletedNodes = G1NbNodes- G2NbNodes; 
				for(int i=0;i<noOfDeletedNodes;i++)
				{

					Node u = ptmp.getNext();
					ptmp.addDistortion( u , Constants.EPS_COMPONENT);

				}
			}

			//Insertion case
			else if(G1NbNodes < G2NbNodes)
			{
				//System.out.println("Insertion phase");
				int noOfInsertedNodes = G2NbNodes- G1NbNodes; 
				for(int i=0;i<noOfInsertedNodes;i++)
				{
					Node u = ptmp.getNextG2();
					ptmp.addDistortion( Constants.EPS_COMPONENT , u );	
				}
			}
		}else{
			return p;
		}

		return ptmp;
	}



	private EditPath loop() {

		boolean condition1;
		boolean condition2;


		//System.out.println("--------------Iteration #"+iteration+"------------------------------------------------------");
		if(OPEN.isEmpty() == true){
			issolutionoptimal=true;
			return UB;
		}

		//On cherche dans OPEN le chemin avec le cout minimum (Pmin) et on l'enlve de OPEN
		EditPath pmin=null;
		MyNode<EditPath> pminNode=null;
		MyNode<EditPath> CurNode=OPEN.root;
		// main loop of the tree search
		//while(OPEN.isEmpty()==false){	

		while(true){
			pminNode=OPEN.pollFirstLowestCost(CurNode);	

			//condition1 : Test if there is any child to explore from CurNode
			//condition2 : Test if CurNode is ROOT node
			condition1 = (pminNode == null);
			condition2 = ((pminNode == null)&&(CurNode.parent != null));
			while( condition1 && condition2){
				//BackTrack : pminNode is null so CurNode has no children. so we get the parent of CurNode
				CurNode =OPEN.BackTrack(CurNode);
				//pollFirstLowestCost : get the cheapest Child Node. The node is removed from the tree
				pminNode=OPEN.pollFirstLowestCost(CurNode);	
				condition1 = (pminNode == null);
				condition2 = ((pminNode == null)&&(CurNode.parent != null));
			}
			//System.out.println("nbexlporednode="+nbexlporednode);		
			if(UB!=null && this.timeconstraint==true){
				//we have reached the time constraint
				return UB;
			}

			//			this.memorylimittest();
			//			if(this.memoryconstraint == true){
			//				//we have reached the time constraint			
			//				return this.UB;
			//			}

			if((pminNode == null) && (CurNode.parent == null) ){
				//all the tree has been explored since pminNode is null and its CurNode is root.
				//no more children to explore
				issolutionoptimal=true;
				return UB;
			}

			pmin = pminNode.data;

			//We cut if pmin is higher than UBCOST
			if(pmin.getTotalCosts()+pmin.ComputeHeuristicCosts(heuristicmethod)<UBCOST){

				// generates all successors of node u in the search tree
				// and add them to open

				this.nbexlporednode++;	
				maxopensize = Math.max(pminNode.children.size(), this.maxopensize);

				if(pmin.getUnUsedNodes1().size() > 0){
					this.CurVertex = pmin.getNext();
					if(debug==true) System.out.println("Current Node="+this.CurVertex.getId());

					//pour tous les noeuds (w)  de V2  qui ne sont pas encore utiliss dans Pmin. on ajoute dans pmin toutes les substitutions de uk+1 avec w.
					LinkedList<Node>UnUsedNodes2= pmin.getUnUsedNodes2();

					for(int i=0;i<UnUsedNodes2.size();i++){
						EditPath newpath = new EditPath(pmin);
						Node w = UnUsedNodes2.get(i);
						newpath.addDistortion(this.CurVertex, w);
						AddTreeNode(pminNode,newpath,this.UBCOST);
					}
					//On met dans pmin une suppresion de uk+1.
					EditPath newpath = new EditPath(pmin);
					newpath.addDistortion(this.CurVertex, Constants.EPS_COMPONENT);
					AddTreeNode(pminNode,newpath,this.UBCOST);


				}else{
					//Sinon si k= taille de G1
					//On met dans pmin toutes les insertions des noeuds  de V2  qui ne sont pas encore utiliss dans Pmin. 
					//On remet Pmin dans OPEN
					//System.out.println("nbexlporednode="+nbexlporednode);
					EditPath newpath = new EditPath(pmin);
					newpath.complete();	
					double g = newpath.getTotalCosts();
					double h = newpath.ComputeHeuristicCosts(heuristicmethod);
					double f= g+h;

					if(f<UBCOST)
					{
						UBCOST = f;
						UB = newpath;
					}


				}//end of if(pmin.getUnUsedNodes1().size() > 0)
			}//end of cut

			//next node to be explored
			//pminNode that has been expanded. Children has been created so we need to go deeper
			CurNode=pminNode;


		}//end of while true



	}





	// the initialization function
	private void inti() {
		// TODO Auto-generated method stub

		for(int i=0;i<G2NbNodes;i++){
			//Dans la liste OPEN on met toutes les substitions de u1 avec tous les noeuds de g2.
			//index du noeud courant

			EditPath p = new EditPath((EditPath) OPEN.root.data); // An intialization for both G1 and G2 "to show that we did not use neither edges nor nodes of both G1 and G2"
			Node v = (Node)G2.get(i);
			this.CurVertex = p.getNext();
			/* Add distortion between the current node u1 and each node in G2 
				 distortion means insertion or substitution but not deletion as we are sure that
				 G2 has nodes as we are inside the for loop of G2 */
			p.addDistortion(this.CurVertex, v);
			if(debug==true) System.out.println("Substitution CurNode G1 and ith node of G2= ("+this.CurVertex.getId()+"  "+v.getId()+")   Cost ="+p.getTotalCosts());
			AddTreeNode(OPEN.root,p,this.UBCOST);



		}

		//On met dans OPEN une suppresion de u1. Dans le cas ou supprimer u1 serait une possibilit optimale.
		EditPath p = new EditPath((EditPath) OPEN.root.data);
		this.CurVertex = p.getNext();
		p.addDistortion(this.CurVertex, Constants.EPS_COMPONENT); // Zeina: deletion
		if(debug==true) System.out.println("Deletion CurNode="+this.CurVertex.getId() + " -- Cost = "+p.getTotalCosts());
		AddTreeNode(OPEN.root,p,this.UBCOST);

	}

	//add a node to the tree if it is worth. if it is lower than UBCOST
	//the new node is linked to its parent node.
	private void AddTreeNode(MyNode<EditPath> parent, EditPath p, double ubcost2) {
		// TODO Auto-generated method stub
		double g=p.getTotalCosts();
		double h=p.ComputeHeuristicCosts(heuristicmethod);
		double f = g+h;
		if(f<ubcost2){
			OPEN.Add(parent,p);	
		}
	}


	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		// TODO Auto-generated method stub
		//	t3();
		//	t4();
		
	}

	private static void t4() throws Exception {
		// TODO Auto-generated method stub
		File outputFile;
		Constants.timer = new Timer();	
		//ps.println("14;;;;;;;;;;;;;;;");

		PrintStream ps=null;

		String dbDirecttory="";
		String readTrainingCXLFile="";
		int numberOfDB=1;

		if(numberOfDB==1)
		{
			double nodeCosts=90;
			double edgeCosts=15;
			double alpha=0.50;
			Constants.timeconstraint = 1000;
			Constants.costFunction = new GRECCostFunction(nodeCosts, edgeCosts, alpha);
			Constants.edgeHandler = new UniversalEdgeHandler(); 

			dbDirecttory = "F:/PhD/PHDsvn/BipartiteGraphMatchingEditDistance/data/IAM/GREC";
			readTrainingCXLFile = "F:/PhD/PHDsvn/BipartiteGraphMatchingEditDistance/data/IAM/GRECtrainCXL/train10.cxl";

			outputFile=new File("F:/PhD/PHDsvn/BipartiteGraphMatchingEditDistance/output-GREC10-Hausdorff.csv");
			ps = new PrintStream(outputFile);

			System.out.println("Hello .....");


			ps.println("Method,Param,Graph1 Name,Graph2 Name,Graph1 nb nodes,Graph2 nb nodes,Graph1 nb edges,Graph2 nb edges,distance,#explored nodes,max open size,time,feasible solution found,optimal solution found,memory overflow,time overflow,G1 class,G2 class");

		}

		if(numberOfDB==2)
		{
			double nodeCosts=11;
			double edgeCosts=1.1;
			double alpha=0.25;
			outputFile=new File("F:/PhD/PHDsvn/BipartiteGraphMatchingEditDistance/output-Mutagen.csv");

			Constants.costFunction = new MutagenCostFunction(nodeCosts,edgeCosts,alpha);
			Constants.edgeHandler = new UniversalEdgeHandler(); 
			dbDirecttory = "F:/PhD/PHDsvn/BipartiteGraphMatchingEditDistance/data/IAM/Mutagenicity";
			readTrainingCXLFile = "F:/PhD/PHDsvn/BipartiteGraphMatchingEditDistance/data/IAM/Mutagenicity/train30.cxl";
			ps = new PrintStream(outputFile);

			System.out.println("Hello .....");


			ps.println("Method,Param,Graph1 Name,Graph2 Name,Graph1 nb nodes,Graph2 nb nodes,Graph1 nb edges,Graph2 nb edges,distance,#explored nodes,max open size,time,feasible solution found,optimal solution found,memory overflow,time overflow,G1 class,G2 class");

		}


		XMLElement trainXML = new XMLElement();
		FileReader trainReader = new FileReader(readTrainingCXLFile);
		trainXML.parseFromReader(trainReader);
		Vector trainListchildren = trainXML.getChildren();
		XMLElement trainRoot = (XMLElement) trainListchildren.get(0);
		Enumeration trainEnumerator = trainRoot.enumerateChildren();



		XMLParser xmlParser = new XMLParser();

		while (trainEnumerator.hasMoreElements()) 
		{

			XMLElement trainChild = (XMLElement) trainEnumerator.nextElement();
			String trainGraphFileName=(String) trainChild.getAttribute("file", null);
			String trainGraphClass = (String) trainChild.getAttribute("class", "NO_CLASS");
			Graph g1 = xmlParser.parseGXL(dbDirecttory+"/"+trainGraphFileName);

			Enumeration trainEnumerator1 = trainRoot.enumerateChildren();

			while (trainEnumerator1.hasMoreElements()) 
			{
				XMLElement trainChild1 = (XMLElement) trainEnumerator1.nextElement();
				String trainGraphFileName1=(String) trainChild1.getAttribute("file", null);
				String trainGraphClass1 = (String) trainChild1.getAttribute("class", "NO_CLASS");
				Graph g2 = xmlParser.parseGXL(dbDirecttory+"/"+trainGraphFileName1);

				ps.print("HDFS,");
				ps.print("rien,");
				ps.print(trainGraphFileName+",");
				ps.print(trainGraphFileName1+",");
				ps.print(g1.size()+",");
				ps.print(g2.size()+",");
				ps.print(g1.getEdges().size()+",");
				ps.print(g2.getEdges().size()+",");

				long start = System.currentTimeMillis();
				GEDDFS HGED = new GEDDFS(g1,g2,Constants.costFunction,Constants.edgeHandler,EditPath.LAPAssigmentHeuristic,MunkresUB,true,false);
				long end = System.currentTimeMillis();
				ps.print(HGED.getBestEditpath().getTotalCosts()+",");
				ps.print(HGED.nbexlporednode+",");
				ps.print(HGED.maxopensize+",");

				//	System.out.println("nb :: "+HGED.nbexlporednode);
				//	System.out.println("open ::"+HGED.maxopensize);
				long delay = end-start;

				ps.print(delay+",");
				ps.print(false+",");
				ps.print(false+",");
				ps.print(false+",");
				ps.print(false+",");
				ps.print(trainGraphClass+",");
				ps.println(trainGraphClass1+"");
				System.out.println("Distance ......"+HGED.getBestEditpath().getTotalCosts());

			}
		}
		ps.close();
		System.out.println("Finished");
	}

	private static FilenameFilter gxlFileFilter = new FilenameFilter() {
		public boolean accept(File dir, String name) {
			return name.endsWith(".gxl");
		}
	};

	private static void t3()
	{
		//Constants.costFunction = (ICostFunction)new LetterCostFunction(1,1,1); 
		double n=90;
		double e=15;
		double a=0.5;
		Constants.costFunction = (ICostFunction)new GRECCostFunction(n,e,a);
		Constants.edgeHandler = new UnDirectedEdgeHandler();

		File repertoire = new File("./data/focus");
		File[] files=repertoire.listFiles(gxlFileFilter);
		//Graph[] graphTab = new Graph[files.length];

		if(!repertoire.exists()){
			System.out.println("Le rpertoire n'existe pas");
		}

		//		XMLParser xmlParser = new XMLParser();
		//		try
		//		{
		//			for(int i=0;i<files.length;i++)
		//			{	
		//				//graphTab[i] = xmlParser.parseGXL(files[i].toString());
		//				System.out.println(files[i].toString());
		//			}
		//		} catch (Exception e) {
		//			// TODO Auto-generated catch block
		//			e.printStackTrace();
		//		}

		try {
			SpeedEvalTest SET = new SpeedEvalTest("gedspeed" +100 + ".txt");
			FileWriter fw = new FileWriter("./data/focus/testjavadfs.csv", true);
			BufferedWriter output = new BufferedWriter(fw);
			output.write("Graph1;Graph2;Cout;Temps\n");
			Graph g2,g1;
			g2=g1=null;
			for(int i=0;i<files.length;i++)
			{
				try {
					XMLParser xmlParser = new XMLParser();
					g1 =  xmlParser.parseGXL(files[i].toString());
				} catch (Exception e3) {
					// TODO Auto-generated catch block
					e3.printStackTrace();
				}
				for(int j=0;j<files.length;j++)//graphTab.length;j++)
				{	
					try {
						XMLParser xmlParser = new XMLParser();
						g2 =  xmlParser.parseGXL(files[j].toString());
					} catch (Exception e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					output.write(g1.getId() + ";" + g2.getId());
					SET.StartChrono();
					GEDDFS HGED = new GEDDFS(g1,g2,Constants.costFunction,Constants.edgeHandler,EditPath.LAPAssigmentHeuristic,MunkresUB,true,false);



					SET.StopChrono();
					output.write(";"+HGED.getBestEditpath().getTotalCosts()+";"+SET.ElapsedTimeToString());
					System.out.println(i + " " + j );
					output.write("\n");
				}
			}
			output.flush();
			output.close();
		} catch (IOException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}

	}


	public EditPath getBestEditpath() {
		// TODO Auto-generated method stub
		return UB;
	}

	public int getNbExploredNode() {
		// TODO Auto-generated method stub
		return this.nbexlporednode;
	}

	public int getMaxSizeOpen() {
		// TODO Auto-generated method stub
		return this.maxopensize;
	}

	public boolean isSolutionoptimal() {
		// TODO Auto-generated method stub
		return issolutionoptimal;
	}

	private boolean memoryconstraint=false;

	public boolean isMemoryconstraintover() {
		return memoryconstraint;
	}

	private boolean memorylimittest() {
		// TODO Auto-generated method stub


		long javaAllocatedMemory = Runtime.getRuntime().totalMemory()/Constants.MegaBytes;
		long javaFreeMemory = Runtime.getRuntime().freeMemory() / Constants.MegaBytes;
		javaFreeMemory =  javaFreeMemory +(Constants.memoryconstraint-javaAllocatedMemory);


		/*System.out.println("javaFreeMemory !::::::"+ javaFreeMemory);
		System.out.println("mem::::"+Constants.memoryconstraint);
		System.out.println("***********************************");*/


		if(javaFreeMemory<=0){
			memoryconstraint=true;
			return true;
		}
		return false;
	}



}
