package algorithms;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Timer;
import java.util.TimerTask;
import java.util.Vector;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

import algorithms.Constants;
import algorithms.MatrixGenerator;
import algorithms.Munkres;
import algorithms.MunkresRec;

import nanoxml.XMLElement;


import algorithms.AscendingOrderNonStaticNodeComparator;
import util.EditPath;
import util.GRECCostFunction1;
import util.Graph;
import util.ICostFunction;
import util.IEdgeHandler;
import util.MutagenCostFunction1;
import algorithms.NonStaticNode;

import algorithms.NonStaticTree;
import util.UniversalEdgeHandler;
import util.MyTree.MyNode;
import util.Node;
import xml.XMLParser;

public class GEDDFSThread extends Thread{

	double idletime=0;
	public double getIdletime() {
		return idletime;
	}


	double starttime;
	double endtime;
	double cputime=0;
	public double getCputime() {
		return cputime;
	}




	//double wctAvant;  
	NonStaticTree OPEN; // Tiens  jour la liste des noeud non encore utiliss. Le score du chemin.

	private Node CurVertex; //Current node
	public int openCounterSize; // a variable that tracks the maximum size of the set OPEN
	public  int editPathCounter; // a variable that tracks number of edit paths

	//debug info
	//debug variable
	public int nbexlporednode=0;
	public int maxopensize=0;

	
	public double noOfIterations = 0.0;
	public double varianceSum = 0.0;

	boolean debug;


	private int heuristicmethod;





	////////////////////////////////////////////////////////////////////////////////////////////
	public GEDDFSThread(int heuristic,boolean debug){
		//inittimer();

		
		this.debug = debug;
		heuristicmethod = heuristic;
		//heuristicmethod = EditPath.HausdorffEDHeuristic;
		//La liste OPEN est initialise  VIDE. OPEN est une liste de chemin
		//Zeina: The set open contains the search tree nodes to be processed in the next steps





	}

	void SetRootNode(EditPath ROOT,AscendingOrderNonStaticNodeComparator MyNodeComparator){
		OPEN = new NonStaticTree<EditPath>(ROOT,MyNodeComparator);	
	}




	private boolean issolutionoptimal=false;

	private TimerTask task;

	public static int MunkresUB=0;
	public static int DummyUB=1;

	public boolean isTimeconstraintover() {
		return GlobalVar.timeconstraint;
	}








	private EditPath loop() throws FileNotFoundException {

		
		boolean condition1;
		boolean condition2;
		
		//System.out.println("Thread "+Thread.currentThread().getName()+ "   "+OPEN.nbnodes);
		//int kk=0;
		
		String threadFile = ""+Thread.currentThread().getName()+".csv";

		//On cherche dans OPEN le chemin avec le cout minimum (Pmin) et on l'enlve de OPEN
		EditPath pmin=null;
		NonStaticNode<EditPath> pminNode=null;
		NonStaticNode<EditPath> CurNode=OPEN.root;
	
		
		// main loop of the tree search
		while(true){

			////	noOfIterations++;
			//////////////////////////////////////////////////////////////////////////////////
	//	    ps.print(GlobalVar.tabthreads[this.IdThread].OPEN.globalworkload + ";");			
        	////		double avg1 =  ComputerAverageWorkLoad(false); 
	//		ps.print(avg1+";");
			
			////		double result =  GlobalVar.tabthreads[this.IdThread].OPEN.globalworkload - ComputerAverageWorkLoad(false);
			////		result = result * result;		
			////		varianceSum += result;

			//////////////////////////////////////////////////////////////////////////////////

			
			if(GlobalVar.timeconstraint==true){
				
				return FinishThread(false);			
				
			}

		//	this.memorylimittest();
		/*	if(GlobalVar.memoryconstraint == true){
				
				System.out.println("memory ....");
				return FinishThread(false);
			}
		*/

	
			
			ProcessHeavyThread(CurNode);

			
			

			pminNode=OPEN.pollFirstLowestCost(CurNode);	

			//condition1 : Test if there is any child to explore from CurNode
			//condition2 : Test if CurNode is ROOT node
			condition1 = (pminNode == null);
			condition2 = ((pminNode == null)&&(CurNode.parent != null));
			while( condition1 && condition2){
				//BackTrack : pminNode is null so CurNode has no children. so we get the parent of CurNode
				CurNode =OPEN.BackTrack(CurNode);
				//pollFirstLowestCost : get the cheapest Child Node. The node is removed from the tree
				pminNode=OPEN.pollFirstLowestCost(CurNode);	
				condition1 = (pminNode == null);
				condition2 = ((pminNode == null)&&(CurNode.parent != null));
			}


			
		
				if((pminNode == null) && (CurNode.parent == null) ){
					//return this.FinishThread(true);
					//all the tree has been explored since pminNode is null and its CurNode is root.
					//no more children to explore
					//in the sequential program, it is the case of optimality.
					//we have fully explore the tree
					//in this multi threaded  version, it means we need to steal some jobs

					//Here we check if the thread elected to be stolen is the current thread
					//the selected threas is the most heavy loaded thread
					//the selected thread should not enter here caus it risks to be block by the lock
					if(  GlobalVar.selectedthread  != this.IdThread ){
						//System.out.println("thread attend le lock="+this.IdThread);
						//only one thread at the time can steal jobs		
						if(GlobalVar.timeconstraint==true) return this.FinishThread(false);
						GlobalVar.loadbalancelock.lock();
						//let us start a timer to see how long it takes to steal jobs
						this.starttime=System.currentTimeMillis();					
						//System.out.println("on prend le lock du load"+this.IdThread);
						//the lighted thread is a thread with no jobs
						GlobalVar.lightthread =this.IdThread;
						//selected thread is the most busy thread
						GlobalVar.selectedthread  = findthemostloadedthread();
						//System.out.println("thread "+GlobalVar.lightthread+"  attend thread "+GlobalVar.selectedthread);
						//if the most busy and the less busy thread are the same then there is no more jobs todo
						if(GlobalVar.lightthread ==GlobalVar.selectedthread || GlobalVar.selectedthread==-1 ){
							return FinishWaitingThreadOptimality(true);					
						}
						//we computer the average load for all threads
						//double avg = this.ComputerAverageWorkLoad(false);
						double avg =  GlobalVar.tabthreads[GlobalVar.selectedthread].OPEN.globalworkload; 
						//if the average load is 0
						//then we must finish the thread
						if(avg == 0  ){
							return FinishWaitingThreadOptimality(true);
						}
						
						
						
						try {
							//ok we know the most busy thread
							//let us wait untill it gets the notification and it gives us some jobs
							//System.out.println("Mutex je suis ="+this.IdThread+" et "+"j'attends ="+GlobalVar.selectedthread);
							//System.out.println(" balancing=");
							//ComputerAverageWorkLoad(true);	
							GlobalVar.mutex.acquire();
							//System.out.println("j'ai mutex="+this.IdThread);
						} catch (InterruptedException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						
						//Oh oh there is nothing to do no more jobs ?
						// it might be because the others threads have finished everything
						//it might be because the selected thread has been stopped by the time constraint
						if(GlobalVar.timeconstraint==true){
							//we fail to exchange jobs
							//probably there is no jobs to do
							return FinishWaitingThreadOptimality(false);
						}
						

						if(GlobalVar.memoryconstraint==true){
							//we fail to exchange jobs
							//probably there is no jobs to do
							return FinishWaitingThreadOptimality(false);
						}
						
							//I get my next jobs
						pminNode=OPEN.pollFirstLowestCost(this.OPEN.root);	

						
						if(pminNode==null && this.ComputerAverageWorkLoad(false)==0){
							
							//we fail to exchange jobs
							//probably there is no jobs to do
							return FinishWaitingThreadOptimality(true);
						}
						
						
						
						if(pminNode==null){
							
							//we fail to exchange jobs
							//probably there is no jobs to do
							return FinishWaitingThreadOptimality(false);
						}
						
						//ok the job stlealing is over so let us 
						//check how long it takes
						this.endtime=System.currentTimeMillis();
						this.idletime+=endtime-starttime;
						
						//the mutex was released I might have some jobs to do now
						//reset of the variable for the next
						GlobalVar.lightthread=-1;
						GlobalVar.selectedthread=-1;
						//System.out.println("on rend le lock du load"+this.IdThread);
						//we release the lock for the next thread
						GlobalVar.loadbalancelock.unlock();
						
					}

				}
				
				
				
				if(pminNode==null){
					if( this.ComputerAverageWorkLoad(false)==0){
						
						return FinishThread(true);
					}else{
						System.out.println("error= "+this.IdThread);
						System.out.println(" balancing=");
						ComputerAverageWorkLoad(true);		
					}				
				}

			
				if((pminNode == null) && (CurNode.parent == null) )
				{
					return FinishThread(true);

				}
			
			pmin = pminNode.data;

			
		/*	 if(kk==0)
	         {
	            	System.out.println("Extract :: "+Thread.currentThread().getName());
	            	kk++;
	         }
		 */


			//We cut if pmin is higher than UBCOST
			if(pmin.getTotalCosts()+pmin.ComputeHeuristicCosts(heuristicmethod)<GlobalVar.UBCOST){

				// generates all successors of node u in the search tree
				// and add them to open

				this.nbexlporednode++;	
				maxopensize = Math.max(pminNode.children.size(), this.maxopensize);

				if(pmin.getUnUsedNodes1().size() > 0){
					this.CurVertex=pmin.getNext();
					if(debug==true) System.out.println("Current Node="+this.CurVertex.getId());

					//pour tous les noeuds (w)  de V2  qui ne sont pas encore utiliss dans Pmin. on ajoute dans pmin toutes les substitutions de uk+1 avec w.
					LinkedList<Node>UnUsedNodes2= pmin.getUnUsedNodes2();

					for(int i=0;i<UnUsedNodes2.size();i++){
						EditPath newpath = new EditPath(pmin);
						Node w = UnUsedNodes2.get(i);
						newpath.addDistortion(this.CurVertex, w);
						AddTreeNode(pminNode,newpath,GlobalVar.UBCOST);
					}
					//On met dans pmin une suppresion de uk+1.
					EditPath newpath = new EditPath(pmin);
					newpath.addDistortion(this.CurVertex, Constants.EPS_COMPONENT);
					AddTreeNode(pminNode,newpath,GlobalVar.UBCOST);


				}else{
					//Sinon si k= taille de G1
					//On met dans pmin toutes les insertions des noeuds  de V2  qui ne sont pas encore utiliss dans Pmin. 
					//On remet Pmin dans OPEN
					//System.out.println("nbexlporednode="+nbexlporednode);
					EditPath newpath = new EditPath(pmin);
					newpath.complete();	
					double g = newpath.getTotalCosts();
					double h = newpath.ComputeHeuristicCosts(heuristicmethod);
					double f= g+h;

					//a section that critical
					//only best UB can be modified
					//so condition must be check by only one thread at the time
					if(f<GlobalVar.UBCOST)
					{
						GlobalVar.ubupdatelock.lock();
						if(f<GlobalVar.UBCOST)
						{
							//let us update the UB
							GlobalVar.UBCOST = f;
							GlobalVar.UB = newpath;

						}
						//Let us release the lock for the next thread to check if the next thread will
						//have a better solution.
						GlobalVar.ubupdatelock.unlock();
					}
				// Added by Zeina for setup Time ...	
				//	GlobalVar.timeconstraint=true;
				}//end of if(pmin.getUnUsedNodes1().size() > 0)
			}//end of cut

			//next node to be explored
			//pminNode that has been expanded. Children has been created so we need to go deeper
			CurNode=pminNode;


		}//end of while true



	}



	private void ProcessHeavyThread(NonStaticNode<EditPath> CurNode) {
		// TODO Auto-generated method stub
		//new piece of cade
		//the current thread is the selected thread
		//the one chosen to be the most busy
		if( this.IdThread==GlobalVar.selectedthread ){
			
			//let us start a timer to compute the idl cpu time
			//if we are here it means we waste time
			//the thread is not doing any tree exploration
			this.starttime=System.currentTimeMillis();

			//a sleep to prevent change of mind from the light thread
			//light thread can decide to not steal jobs
			//but the heavy thread has already caaught the notification
			//to avoid that a small sleep
			try {
				this.sleep(1);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			//we check if since we notice that the thread was loaded and since it gets the 
			//notification we check if the current thread is still busy.
			//it might have finish everything.
			//we must keep in mind that between the moment we compute the function  findthemostloadedthread below 
			//it might have change since we arrive here.
			//GlobalVar.selectedthread  = findthemostloadedthread();
			//We check if selectedthread is not any more the current thread. well it is not the most busy anymore but it can give jobs ?
			//GlobalVar.selectedthread==-1  so there no jobs to do anymore
			//GlobalVar.lightthread==-1 : weird it should not happend cause this value can only be modified in lock function
			//GlobalVar.selectedthread==GlobalVar.lightthread in that case the most busy is the less busy so there is no more jobs to do.
			//GlobalVar.selectedthread != this.IdThread ||
			if( GlobalVar.memoryconstraint==true || GlobalVar.timeconstraint==true || GlobalVar.selectedthread==-1 || GlobalVar.lightthread==-1
					|| GlobalVar.selectedthread==GlobalVar.lightthread || GlobalVar.tabthreads[GlobalVar.selectedthread].OPEN.globalworkload==0){
				
				
				//we reset variables
				GlobalVar.selectedthread=-1;
				GlobalVar.lightthread=-1;
				
				

				//we release the mutex
				//so the less busy thread can go on
				GlobalVar.mutex.release();
			}else{
				//System.out.println("avant load balancing=");
				//we computer the average workload it might have change because 
				//the delay between sending the notification and getting the notification
				//this line is just for displaying
				//line for debuging
				//ComputerAverageWorkLoad(true);	
				//we say the average load is the most heavy thread divided by two
				//the less busy thread will receive half of the most busy
				//GlobalVar.averageworkload=GlobalVar.tabthreads[GlobalVar.selectedthread].OPEN.globalworkload/2.0;
			     GlobalVar.averageworkload=this.ComputerAverageWorkLoad(false);
				//we start the loadblancing
			    //System.out.println("load balancing "+ Thread.currentThread().getName());
				loadbalance(GlobalVar.lightthread,GlobalVar.selectedthread ,CurNode);
				//System.out.println("aprs load balancing=");
				//this line is just for displaying
				//line for debuging
				//this.ComputerAverageWorkLoad(true);
				GlobalVar.lightthread=-1;
				GlobalVar.selectedthread=-1;
				//we release the mutex
				//so the less busy thread can go on
				GlobalVar.mutex.release();
			}
			
			//This is the end of the load balancing so
			//we can compute the time spent doing loadblancing
			//we add this time to idle time
			this.endtime=System.currentTimeMillis();
			this.idletime+=endtime-starttime;
		}
	}

	private EditPath FinishThread(boolean optimal) {
		// TODO Auto-generated method stub
		//System.out.println("thread a fini ="+this.IdThread);
		//if the thread that is dying if the most busy thread then we might
		//release the mutex to let the less busy thread go
		//reset the variable
		//if time out is true and the heaviest thread can die so we put the workload to 0
		GlobalVar.tabthreads[this.IdThread].OPEN.globalworkload=0;
		
		GlobalVar.threadNoOfIterations[this.IdThread]= 	noOfIterations;
		GlobalVar.threadvariance[this.IdThread]= varianceSum;
				
		
		if(this.IdThread==GlobalVar.selectedthread) GlobalVar.mutex.release();
		//we have reached the time constraint
		//we notify to the main thread that the current thread is dead
		this.issolutionoptimal=optimal;
		GlobalVar.sem.release();
		
		//System.out.println("thread is dead="+this.IdThread);
		return GlobalVar.UB;
	}

	private EditPath FinishWaitingThreadOptimality(boolean optimal) {
		// TODO Auto-generated method stub
		//reset the variable
		//if time out is true and the heaviest thread can die so we put the workload to 0
		GlobalVar.tabthreads[this.IdThread].OPEN.globalworkload=0;
		if(this.IdThread==GlobalVar.selectedthread) GlobalVar.mutex.release();
		GlobalVar.selectedthread=-1;
		//the branch has been explored fully might be optimal
		
		
		GlobalVar.threadNoOfIterations[this.IdThread]= 	noOfIterations;
		GlobalVar.threadvariance[this.IdThread]= varianceSum;
				
		
		
		issolutionoptimal=optimal;
		//ok we can computer the idle time.
		this.endtime=System.currentTimeMillis();
		this.idletime+=endtime-starttime;
		//we give back the lock
		GlobalVar.lightthread=-1;
		//System.out.println("on rend le lock du load"+this.IdThread);
		GlobalVar.loadbalancelock.unlock();
	
		//we say to the main thread that this thread is over
		GlobalVar.sem.release();	
		//System.out.println("thread is dead="+this.IdThread);
		return GlobalVar.UB;
	}

	private void loadbalance(int lightthread,int hevyidthread,NonStaticNode CurNode) {
		// TODO Auto-generated method stub
		//The thread requested jobs has been set to -1. This is not normal ? 
		//Well it can happen cause first the say yes this thread is selected then 
		//we change our mind but the selected thread caught the notification so to limit 
		//this i put a sleep when the notification is caucght and before checking 
		//the light thread still needs jobs
		
		
		NonStaticNode CurNode2 =CurNode; 
		double halfworkload = GlobalVar.tabthreads[hevyidthread].OPEN.globalworkload/2.0;
		if(lightthread ==-1){
			System.out.println("The thread requested jobs has been set to -1. This is not normal ? Well it can happen cause first the say yes this thread is selected then we change our mind but the selected thread caught the notification so to limit this i put a sleep when the notification is caucght and before checking the light thread still needs jobs");
			
			return;
		}
		
		int isLightThread = 1;
		while( 
				//the light thread is under the average
				GlobalVar.tabthreads[lightthread].OPEN.globalworkload<halfworkload
				){
			ArrayList nodes;
			//NonStaticNode node = GlobalVar.tabthreads[hevyidthread].OPEN.getBestLeaf(GlobalVar.tabthreads[hevyidthread].OPEN.root);
			//let us get one job
			if(isLightThread == 1)
			{
				nodes  = GlobalVar.tabthreads[hevyidthread].OPEN.searchLowestCost(CurNode2, 1);
				isLightThread = 0;
			}
			else
			{
				nodes  = GlobalVar.tabthreads[hevyidthread].OPEN.searchLowestCost(CurNode2, 0);
				isLightThread = 1;
			}
			//we fail to retreive one job so we go away
			//we probably steal everything from the heavy thread
			if(nodes == null || nodes.size()==0){
				//System.out.println("error heavy loaded thread is out of jobs ????");
				//System.out.println("Light workload="+GlobalVar.tabthreads[lightthread].OPEN.globalworkload);
				//System.out.println("Light hevyidthread="+GlobalVar.tabthreads[hevyidthread].OPEN.globalworkload);
				//System.out.println("error heavy loaded thread is out of jobs ????");
				break;
			}
			//we get the job
			NonStaticNode node = (NonStaticNode) nodes.get(0);
			CurNode2 = (NonStaticNode) nodes.get(1);
			//we add the job to the light thread
			GlobalVar.tabthreads[lightthread].addJob((EditPath) node.data);

		}
	}

	private int findthemostloadedthread() {
		// TODO Auto-generated method stub
		double maxvalue=-1;
		int maxindex=-1;
		for(int i=0;i<GlobalVar.tabthreads.length;i++){
			if(maxvalue<GlobalVar.tabthreads[i].OPEN.globalworkload 
					){
				maxvalue=GlobalVar.tabthreads[i].OPEN.globalworkload;
				maxindex=i;
			}
		}
		return maxindex;
	}

	private double ComputerAverageWorkLoad(boolean b) {
		// TODO Auto-generated method stub

		double avg=0;
		for(int i=0;i<GlobalVar.tabthreads.length;i++){
			if (b==true )System.out.print(GlobalVar.tabthreads[i].OPEN.globalworkload+"  ");
			avg+=GlobalVar.tabthreads[i].OPEN.globalworkload;
		}
		if (b==true ) System.out.println();
		return avg/(double)GlobalVar.tabthreads.length;

	}

	//add a node to the tree if it is worth. if it is lower than UBCOST
	//the new node is linked to its parent node.
	private void AddTreeNode(NonStaticNode<EditPath> parent, EditPath p, double ubcost2) {
		// TODO Auto-generated method stub
		double g=p.getTotalCosts();
		double h=p.ComputeHeuristicCosts(heuristicmethod);
		double f = g+h;
		if(f<ubcost2){
			OPEN.Add(parent,p);	
		}
	}


	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		// TODO Auto-generated method stub
		//	t3();
		//	t4();
		//t1();
	}



	public EditPath getBestEditpath() {
		// TODO Auto-generated method stub
		return GlobalVar.UB;
	}

	public int getNbExploredNode() {
		// TODO Auto-generated method stub
		return this.nbexlporednode;
	}

	public int getMaxSizeOpen() {
		// TODO Auto-generated method stub
		return this.maxopensize;
	}

	public boolean isSolutionoptimal() {
		// TODO Auto-generated method stub
		return issolutionoptimal;
	}

	//private boolean memoryconstraint=false;

	private GEDMultiThreadGREC motherclass;

	private int IdThread;

	public boolean isMemoryconstraintover() {
		return GlobalVar.memoryconstraint;
	}

	

	@Override
	public void run() {

		// TODO Auto-generated method stub
	///	System.out.println("inside run ...");
		this.cputime=System.currentTimeMillis();
		try {
			loop();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.cputime=System.currentTimeMillis()-cputime;
	}

	public void addJob(EditPath editPath) {
		// TODO Auto-generated method stub
		AddTreeNode(this.OPEN.root,editPath,Double.MAX_VALUE);
		//AddTreeNode(this.OPEN.root,editPath,GlobalVar.UBCOST);
		this.OPEN.root.issorted=false;
	}

	public void setMotherClass(GEDMultiThreadGREC gedMultiThread) {
		// TODO Auto-generated method stub
		this.motherclass = gedMultiThread;
	}

	public void SetIdThead(int i) {
		// TODO Auto-generated method stub
		this.IdThread=i;
	}








}
