package algorithms;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.PrintStream;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Timer;
import java.util.TimerTask;



import util.EditPath;
import util.GRECCostFunction1;
import util.Graph;
import util.ICostFunction;
import util.IEdgeHandler;
import util.MutagenCostFunction1;
import util.Node;
import util.UniversalEdgeHandler;
import util.UnlabeledCostFunction;
import xml.XMLParser;
import xml.XMLWriter;



public class HeuristicGraphEditDistanceMUTA {


	ArrayList<EditPath> OPEN; //Tiens  jour la liste des noeud non encore utiliss. Le score du chemin.
	private Graph G1; // Graph 1	
	private Graph G2; // Graph 2
	private Node CurNode; //Current node
	private int G2NbNodes; //number of nodes of G2
	public int openCounterSize; // a variable that tracks the maximum size of the set OPEN
	public  int editPathCounter; // a variable that tracks number of edit paths
	
	
	//debug info
	//debug variable
	int nbexlporednode=0;
	int maxopensize=0;
	
	private EditPath BestEditpath=null; // Zeina: The best answer
	boolean debug;
	private int heuristicmethod;
	private boolean isthereanyfeasibleolutionfound=false;

	public boolean isIsthereanyfeasibleolutionfound() {
		return isthereanyfeasibleolutionfound;
	}

	// A function that returns the best edit path "the optimal solution"
	public EditPath getBestEditpath() {
		return BestEditpath;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////
	public HeuristicGraphEditDistanceMUTA(Graph G1, Graph G2,ICostFunction costfunction, IEdgeHandler edgehandler,int heuristicmethod,boolean debug){
		inittimer();
		this.debug = debug;
		this.G1 =G1;
		this.G2=G2;
		this.heuristicmethod=heuristicmethod;
		G2NbNodes = G2.size(); // Number of nodes of G2
		BestEditpath=null; // In the beginning, the list is empty. 
		//La liste OPEN est initialise  VIDE. OPEN est une liste de chemin
		//The set open contains the search tree nodes to be processed in the next steps
		OPEN = new ArrayList<EditPath>();
		//avant la boucle
		inti();
		BestEditpath = loop();
		
		task.cancel();
		Constants.timer.purge();
		Constants.edgecostmatrix=null;
		Constants.nodecostmatrix=null;
	}
	
	
	public HeuristicGraphEditDistanceMUTA(Graph G1, Graph G2,ICostFunction costfunction, IEdgeHandler edgehandler,boolean debug){
		inittimer();
		this.debug = debug;
		this.G1 =G1;
		this.G2=G2;
		this.heuristicmethod=EditPath.NoAssigmentHeuristic;
		G2NbNodes = G2.size(); // Number of nodes of G2
		BestEditpath=null; // In the beginning, the list is empty. 
		//La liste OPEN est initialise  VIDE. OPEN est une liste de chemin
		//The set open contains the search tree nodes to be processed in the next steps
		OPEN = new ArrayList<EditPath>();
		//avant la boucle
		inti();
		BestEditpath = loop();
		task.cancel();
		Constants.timer.purge();
		Constants.edgecostmatrix=null;
		Constants.nodecostmatrix=null;
	}
	////////////////////////////////////////////////////////////////////////////////////////////
	private EditPath loop() {
		// TODO Auto-generated method stub

		while(true == true){
			
			if(OPEN.isEmpty() == true){
				System.out.println("Error : No more candidates, no complete solution could be found");
				System.out.println("Error : Please check your graph data");
				return null;
			}
			if(debug==true) System.out.println("----------------------------------------------------------");
			
			//On cherche dans OPEN le chemin avec le cout minimum (Pmin) et on l'enlve de OPEN
			EditPath pmin =findmincostEditPathWithHeuristic(OPEN);

			OPEN.remove(pmin);
			
			if(debug==true) 
			{
				System.out.println("---------------Choosing the minimal cost-------------------------------------------");
				pmin.ComputeHeuristicCosts(heuristicmethod);
				System.out.println("Cost (g):"+pmin.getTotalCosts());
				System.out.println("Cost (h):"+pmin.getHeuristicCosts());
				System.out.println("Current Path=");
				pmin.printMe();
			}
			if(this.timeconstraint==true || this.memoryconstraint == true){
				//we have reached the time constraint
				if(BestEditpath==null){
					BestEditpath =pmin;
				}
				return this.BestEditpath;
			}

			if(pmin.isComplete() == true){
				this.isthereanyfeasibleolutionfound=true;
				issolutionoptimal=true;
				return pmin;
			}else{
				// K est l'index du noeud de G1 en cours de traintement. Premier courp, k=1. 
				// Si on a trait  k < taille de G1
				
				if(pmin.getUnUsedNodes1().size() > 0){;
					this.CurNode=pmin.getNext();
					if(debug==true) System.out.println("Current Node="+this.CurNode.getId());
					
					// pour tous les noeuds (w)  de V2  qui ne sont pas encore utiliss dans Pmin. on ajoute dans pmin toutes les substitutions de uk+1 avec w.
					LinkedList<Node>UnUsedNodes2= pmin.getUnUsedNodes2();
					for(int i=0;i<UnUsedNodes2.size();i++){
						EditPath newpath = new EditPath(pmin);
						
						Node w = UnUsedNodes2.get(i);
						newpath.addDistortion(this.CurNode, w);
						if(debug==true)
						{
							System.out.println("Substitution CurNode and ith node of G2= "+ this.CurNode.getId()+ " -- "+ w.getId());
							newpath.ComputeHeuristicCosts(heuristicmethod);
						    newpath.printMe();
						}
							
						this.OPEN.add(newpath);
						if(debug==true) TrackOpenEditPathSize();
						if(debug==true) System.out.println("----------------------------------------------------------");
					}
					// On met dans pmin une suppresion de uk+1.
					EditPath newpath = new EditPath(pmin);
					newpath.addDistortion(this.CurNode, Constants.EPS_COMPONENT);
					if(debug==true) 
					{
						System.out.println("Deletion CurNode="+this.CurNode.getId());
						newpath.ComputeHeuristicCosts(heuristicmethod);
						newpath.printMe();
						System.out.println("----------------------------------------------------------");
					}
					
					this.OPEN.add(newpath);
					if(debug==true) TrackOpenEditPathSize();

				}else{
					//Sinon si k= taille de G1
					//On met dans pmin toutes les insertions des noeuds  de V2  qui ne sont pas encore utiliss dans Pmin. 
					//On remet Pmin dans OPEN
					EditPath newpath = new EditPath(pmin);
					newpath.complete();	
					this.OPEN.add(newpath);
					
					if(this.BestEditpath==null){
						BestEditpath=newpath;
					}
					
					if(this.BestEditpath.getTotalCosts()>newpath.getTotalCosts()){
						BestEditpath=newpath;
					}
					this.isthereanyfeasibleolutionfound=true;
					
					if(debug==true) TrackOpenEditPathSize();
					
					if(debug==true)
					{
						System.out.println("We complete the path by inserting all remaining nodes of G2 CurNode="+this.CurNode.getId());
						newpath.printMe();
					}
						
				}//fin si k<(this.G1NbNodes-1)
			}//fin si chemin optimal

		}//boucle while
	}
	
	

	//A function that returns the minimal edit path's cost in the set OPEN
	private EditPath findmincostEditPathWithHeuristic(ArrayList<EditPath> oPEN2) {
		// TODO Auto-generated method stub
		int i=0;
		int nbpaths = OPEN.size();
		double minvalue = Double.MAX_VALUE;
		double h=0.0,g=0.0;
		int indexmin = -1;

		for(i=0;i<nbpaths;i++){
			EditPath p = OPEN.get(i);
			g = p.getTotalCosts(); // computing the cost of the edit path from the root till the current node...
			h=p.ComputeHeuristicCosts(this.heuristicmethod);
				
			if((g+h) <minvalue){
				minvalue = g+h;
				indexmin = i;
			}
		}

		this.nbexlporednode++;
		maxopensize = Math.max(this.OPEN.size(), this.maxopensize);
		return OPEN.get(indexmin);
	}
	
	//----------------------------------------------------------------------------------------
	// the initialization function
	private void inti() {
		if(G1.size() ==0 && G2.size() ==0){
			System.out.println("G1 has no node inside");
			System.out.println("G2 has no node inside");
			System.out.println("I cannot work !!!");
		}
		
		if(G1.size() ==0 ){
			System.out.println("G1 has no node inside");
			this.G1=G2;
			this.G2=G1;
			G2NbNodes = G2.size();
			//p = new EditPath(G2,G1,this.heuristicmethod);
		}
		EditPath root = new EditPath(G1,G2); // An intialization for both G1 and G2 "to show that we did not use neither edges nor nodes of both G1 and G2"
		
		// TODO Auto-generated method stub
		for(int i=0;i<G2NbNodes;i++){
			//Dans la liste OPEN on met toutes les substitions de u1 avec tous les noeuds de g2.
			//index du noeud courant
			EditPath p = new EditPath(root); // An intialization for both G1 and G2 "to show that we did not use neither edges nor nodes of both G1 and G2"
		
			Node v = (Node)G2.get(i);
			this.CurNode = p.getNext();
			/*Add distortion between the current node u1 and each node in G2 
			 distortion means insertion or substitution but not deletion as we are sure that
			 G2 has nodes as we are inside the for loop of G2 */
			p.addDistortion(this.CurNode, v);
			if(debug==true) System.out.println("Substitution CurNode G1 and ith node of G2="+this.CurNode.getId()+"  "+v.getId());
			OPEN.add(p);
			if(debug==true) TrackOpenEditPathSize();
		}

		//L3 : On met dans OPEN une suppresion de u1. Dans le cas ou supprimer u1 serait une possibilit optimale.
		EditPath p = new EditPath(root);
		this.CurNode = p.getNext();
		p.addDistortion(this.CurNode, Constants.EPS_COMPONENT); // Zeina: deletion
		if(debug==true) System.out.println("Deletion CurNode="+this.CurNode.getId());
		OPEN.add(p);
		if(debug==true) TrackOpenEditPathSize();
	}
	//----------------------------------------------------------------------------------------

	
	// A function that tracks the no of unexamined "added" edit Paths and the maximum size of the set OPEN
	private void TrackOpenEditPathSize() {
		// TODO Auto-generated method stub
		this.editPathCounter++;
		if(openCounterSize < OPEN.size())
		{
			openCounterSize=OPEN.size();
			if(debug==true)
			{
				System.out.println("OPEN max size = "+openCounterSize);
				System.out.println("No of edit paths = "+editPathCounter);
			
			}
		}
	}

	
	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		
	
		
		Graph g2,g1;
		
		Constants.timer = new Timer();	
		Constants.timeconstraint = 30000;  // time limit: 30 seconds


		XMLParser xmlParser = new XMLParser();

		
		double nodesub = Double.parseDouble(args[0]);
		double nodeinsertdel = Double.parseDouble(args[1]);
		
		double edgesub = Double.parseDouble(args[2]);
		double edgeinsertdel = Double.parseDouble(args[3]);

		
		g1=xmlParser.parseGXL(args[4]);
		g2=xmlParser.parseGXL(args[5]);
		
		

		
		Constants.costFunction = new MutagenCostFunction1(nodesub,nodeinsertdel,edgesub,edgeinsertdel);
		Constants.edgeHandler = new UniversalEdgeHandler(); 

		
		long start = System.nanoTime();
		HeuristicGraphEditDistanceMUTA HGED = new HeuristicGraphEditDistanceMUTA(g1,g2,Constants.costFunction,Constants.edgeHandler,EditPath.MunkresAssigmentHeuristic,false);
		long end = System.nanoTime();

		long executionTime_NanoSeconds = end - start;
		
		// 	System.out.println("in milliseconds :: "+executionTime_NanoSeconds);
			
		double executionTime_seconds = (double)executionTime_NanoSeconds / (double)1000000000;
			
	
		PrintStream ps = new PrintStream(args[6]);
		
		ps.println("Opt_sol;time;node_match");
		ps.print(HGED.issolutionoptimal+";");
		ps.print(new DecimalFormat("##.########").format(executionTime_seconds)+";");
		ps.println(HGED.BestEditpath.g2Indices1(g1));
		ps.close();
		
		
		/*System.out.println("Distance ::::::::::::: "+HGED.getBestEditpath().getTotalCosts());
		System.out.println("Time ??" + HGED.isTimeconstraintover());
		System.out.println("Memory ??" + HGED.isMemoryconstraintover());
		
		System.out.println("After executing the Heuristic Graph Edit Distance function ");
		*/
		
		
		
		System.exit(0);
		
	}
	



	public int getNbExploredNode() {
		// TODO Auto-generated method stub
		return this.nbexlporednode;
	}

	public int getMaxSizeOpen() {
		// TODO Auto-generated method stub
		return this.maxopensize;
	}
	
	
	protected boolean timeconstraint=false;
	private Timer timer;
	private TimerTask task;

	public boolean isTimeconstraintover() {
		return timeconstraint;
	}

	private void inittimer() {
		// TODO Auto-generated method stub
		task = new TimerTask()
		{
			@Override
			public void run() 
			{
				timeconstraint=true;
			}	
		};
		
		//timer = new Timer();
		Constants.timer.scheduleAtFixedRate(task, Constants.timeconstraint, Constants.timeconstraint);
		//timer.scheduleAtFixedRate(task, 0, 100);
	}
	
	private boolean memoryconstraint=false;
	private boolean issolutionoptimal=false;

	public boolean isMemoryconstraintover() {
		return memoryconstraint;
	}


	public boolean isSolutionoptimal() {
		// TODO Auto-generated method stub
		return issolutionoptimal;
	}
}
